<?php

namespace App\Http\Controllers;

use App\Models\LearnerProfile;
use App\Repositories\Contracts\LearnerProfileRepositoryInterface;
use App\Http\Traits\ResponseTrait;
use App\Http\Resources\ResponseCollection;
use Illuminate\Http\Request;

class LearnerProfileController extends Controller
{
    use ResponseTrait;

    private $learnerProfileRepository;

    public function __construct(LearnerProfileRepositoryInterface $learnerProfileRepository)
    {
        $this->learnerProfileRepository = $learnerProfileRepository;
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        $perPage = $request->per_page ? $request->per_page : 100;

        return new ResponseCollection(
            $this->paginateResponse($this->learnerProfileRepository->all($request), $perPage)
        );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        // $request->validate([
        //     'name' => 'required|string|max:255',
        //     'location' => 'required|string|max:255',
        //     'owner_id' => 'required|numeric',
        // ]);

        $learnerProfile = $this->learnerProfileRepository->create($request->toArray());

        return $this->successResponse($learnerProfile, 'Learner profile added successfully!');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\LearnerProfile  $learnerProfile
     * @return \Illuminate\Http\Response
     */
    public function show(LearnerProfile $learnerProfile)
    {
        return $this->successResponse($learnerProfile);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\LearnerProfile  $learnerProfile
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, LearnerProfile $learnerProfile)
    {
        $this->learnerProfileRepository->update($learnerProfile, $request->toArray());

        return $this->updateResponse('Learner Profile updated successfully!');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\LearnerProfile  $learnerProfile
     * @return \Illuminate\Http\Response
     */
    public function destroy(LearnerProfile $learnerProfile)
    {
        $this->learnerProfileRepository->delete($learnerProfile);

        return $this->updateResponse('Learner Profile deleted successfully!');
    }
}
